#!/usr/bin/env python
# -*- coding UTF-8 -*-

from SimpleGladeApp import SimpleGladeApp
import gtk
import cairo
import cairo.gtk
import time
#import math

class CairoGladeApp(SimpleGladeApp):
	def new(self):
		self.label = "STOP!"
		self.count = 0
		gtk.timeout_add(500, self.on_timeout)
	
	def on_timeout(self):
		self.count += 1
		if self.count > len(self.label):
			self.count = 0
		self.window1.queue_draw()
		return True
	
	def on_expose_event(self, area, event):
		self.ctx = cairo.Context()
		cairo.gtk.set_target_drawable(self.ctx, self.drawingarea1.window)
		width, height = self.drawingarea1.window.get_size()
		size = min(width, height)
		self.ctx.scale(width, height)
		
		self.ctx.set_alpha(0.75)
		self.ctx.set_rgb_color(1, 1, 1)
		self.ctx.rectangle(0, 0, 1, 1)
		self.ctx.fill()

		self.draw_polygon()
		self.draw_text()
		self.draw_tube()

	def draw_polygon(self):
		self.ctx.translate(0.1875, -0.15)
		self.ctx.move_to(0.1875, 0.1875)
		self.ctx.rel_line_to(0.25, 0)
		self.ctx.rel_line_to(0.1875, 0.1875)
		self.ctx.rel_line_to(0, 0.25)
		self.ctx.rel_line_to(-0.1875, 0.1875)
		self.ctx.rel_line_to(-0.25, 0)
		self.ctx.rel_line_to(-0.1875, -0.1875)
		self.ctx.rel_line_to(0, -0.25)
		self.ctx.close_path()
		
		self.ctx.save()
		self.ctx.set_rgb_color(0, 0, 0)
		self.ctx.set_line_width(0.005)
		self.ctx.set_line_join(cairo.LINE_JOIN_BEVEL)
		self.ctx.stroke()
		self.ctx.restore()
		self.ctx.set_rgb_color(1, 0, 0)
		self.ctx.fill()

	def draw_text(self):
		self.ctx.save()
		self.ctx.move_to(0.05, 0.55)
		self.ctx.set_rgb_color(0, 0, 0)
		self.ctx.select_font("babelfish")
		self.ctx.scale_font(0.27)
		self.ctx.show_text(self.label[0:self.count])
		self.ctx.stroke()
		self.ctx.restore()

	def draw_tube(self):
		self.ctx.move_to(0.25, 0.815)
		self.ctx.rel_line_to(0, 0.3)
		self.ctx.rel_line_to(0.125, 0)
		self.ctx.rel_line_to(0, -0.3)
		self.ctx.set_rgb_color(0.2, 0.1, 0.3)	
		self.ctx.close_path()
		self.ctx.save()
		self.ctx.set_rgb_color(0, 0, 0)
		self.ctx.set_line_width(0.005)
		self.ctx.stroke()
		self.ctx.restore()
		self.ctx.fill()
			
app = CairoGladeApp("CairoGladeApp.glade")
app.run()
