#!/usr/bin/env python

import os
import fnmatch

def main():
	excluded = "SimpleGladeApp.py"
	cwd = os.path.abspath(os.curdir)

	examples_index_path = "index.tutor.html"
	examples_index = open(examples_index_path, "w")
	examples_index.write(begin_index_html)

	for example_dir in os.listdir("."):
		if not os.path.isdir(example_dir):
			continue
		os.chdir( os.path.join(cwd,example_dir) )
		print "+++ Entering directory %s" % example_dir
		example_tutor_html_path = "index.tutor.html"
		example_tutor_html = open(example_tutor_html_path, "w")
		example_tutor_html.write(begin_example_html % {"source":example_dir} )

		screenshots =  fnmatch.filter( os.listdir("."), "*.png")
		screenshots = [s for s in screenshots if "thumb" not in s]
		for screenshot in screenshots:
			print "--- Processing screenshot %s" % screenshot
			example_tutor_html.write(include_screenshot % screenshot)
			
		glades =  fnmatch.filter( os.listdir("."), "*.glade")
		for glade in glades:
			print "--- Processing glade %s" % glade
			example_tutor_html.write(include_glade % glade)

		sources = fnmatch.filter( os.listdir("."), "*.py")
		if excluded in sources:
			sources.remove(excluded)
		for source in sources:
			print "--- Processing source %s" % source
			example_tutor_html.write(include_source % source)
				
		example_tutor_html.write(end_example_html)
		example_tutor_html.close()
		os.system("tigrux-tutor.py %s" % example_tutor_html_path)
		examples_index.write(include_example % {"example":example_dir})
		os.chdir(cwd)

	examples_index.write(end_index_html)
	examples_index.close()
	print "*** Creating list of examples"
	os.system("tigrux-tutor.py %s" % examples_index_path)
	print "*** Finished"

begin_example_html = '''\
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<link rel="stylesheet" type="text/css" href="../../pytutor.css" />
		<title>%(source)s</title>
	</head>
	<body>
		<h1>%(source)s</h1>
                <p>
			This example requires <a href="SimpleGladeApp.py">SimpleGladeApp.py</a>,
			don't forget to download it.
               </p>
'''

include_source = '''\
		@include_source(%s)
'''

include_screenshot = '''\
		@include_screenshot(%s)
'''

include_glade = '''\
		@include_glade(%s)
'''


end_example_html = '''\
	</body>
</html>
'''

begin_index_html = '''\
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<link rel="stylesheet" type="text/css" href="../pytutor.css" />
		<title>List of Examples</title>
	</head>
	<body>
		<div class="author">
			Last modification @date@
		</div>
		<div class="author">
			Sandino "tigrux" Flores &lt;tigrux_at_ximian_dot_com&gt;
		</div>
		<h1>List of Examples</h1>
		<ul class="list-examples">
'''

include_example = '''\
		<li><a href="%(example)s/index.html">%(example)s</a></li>
'''

end_index_html = '''\
		</ul>
		<p>
			Examples auto indexed using @create-examples-index.py@
		</p>
	</body>
</html>
'''

if __name__ == "__main__":
	main()
