/* png frontend for cairo_snippets
 * (c) Øyvind Kolås 2004, placed in the public domain
 */

#include "snippets.h"

#define IMAGE_WIDTH  256
#define IMAGE_HEIGHT 256

#define LINE_WIDTH 0.04

/* process a snippet, writing it out to file */
static void
snippet_do_png (int no);

int
main (int argc, char **argv)
{
        int i;

	if (argc > 1) {
	    for (i = 1; i < argc; i++) {
		int snippet = snippet_name2no (argv[i]);
		if (snippet >= 0)
		    snippet_do_png (snippet);
	    }
	} else {
	    for (i=0;i<snippet_count;i++)
		snippet_do_png (i);
	}

        return 0;
}

static void
snippet_do_png (int no)
{
        cairo_t *cr;
        FILE *file;
        char pngfile[1024];

        fprintf (stdout, "processing %s", snippet_name[no]);

        sprintf (pngfile, "%s.png", snippet_name [no]);

        file = fopen (pngfile, "w");

        cr = cairo_create ();

        cairo_set_target_png (cr, file, CAIRO_FORMAT_ARGB32, IMAGE_WIDTH, IMAGE_HEIGHT);

        cairo_save (cr);
          cairo_scale (cr, IMAGE_WIDTH/1.0, IMAGE_HEIGHT/1.0);
          cairo_rectangle (cr, 0,0, 1.0, 1.0);
          cairo_set_rgb_color (cr, 1,1,1);
          cairo_fill (cr);
          cairo_set_rgb_color (cr, 0.0, 0.0, 0.0);

          cairo_set_line_width (cr, LINE_WIDTH);
          snippet_do (cr, no);
        cairo_restore (cr);

        cairo_set_line_width (cr, 2);
        cairo_set_rgb_color (cr, 0.0, 0.0, 0.0);
        cairo_rectangle (cr, 0,0, IMAGE_WIDTH, IMAGE_HEIGHT);
        cairo_stroke (cr);

        cairo_show_page (cr);

        fprintf (stdout, "\n");

        cairo_destroy (cr);
        fclose (file);
}
