/* ps frontend for cairo_snippets
 * (c) Øyvind Kolås 2004, placed in the public domain
 */

#include "snippets.h"

#define WIDTH        256
#define HEIGHT       256

#define X_INCHES (WIDTH  / 96.0)
#define Y_INCHES (HEIGHT / 96.0)
#define X_PPI    300.0
#define Y_PPI    300.0

#define LINE_WIDTH 0.04

/* add a page with the specified snippet to the output pdf file */
static void
write_page (cairo_t *cr,
            int      no);

int
main (void)
{
        int i;
        FILE *file;
        cairo_t *cr;

        file = fopen ("snippets.ps", "w");
        cr = cairo_create ();

        cairo_set_target_ps (cr, file, X_INCHES, Y_INCHES, X_PPI, Y_PPI);

        for (i=0;i<snippet_count;i++)
             write_page (cr, i);

        cairo_destroy (cr);
        fclose (file);

        return 0;
}

static void
write_page (cairo_t *cr,
            int      no)
{
        fprintf (stdout, "processing %s", snippet_name[no]);

        cairo_save (cr);
          cairo_scale (cr, WIDTH/1.0, HEIGHT/1.0);
          cairo_rectangle (cr, 0,0, 1.0, 1.0);
          cairo_set_rgb_color (cr, 1,1,1);
          cairo_fill (cr);
          cairo_set_rgb_color (cr, 0.0, 0.0, 0.0);

          cairo_set_line_width (cr, LINE_WIDTH);
          snippet_do (cr, no);
        cairo_restore (cr);

        cairo_set_line_width (cr, 2);
        cairo_set_rgb_color (cr, 0.0, 0.0, 0.0);
        cairo_rectangle (cr, 0,0, WIDTH, HEIGHT);
        cairo_stroke (cr);

        cairo_show_page (cr);
        fprintf (stdout, "\n");
}
