/* 
 * cairo-widget: A simple demo showing how to draw a Gtk+ widget with cairo.
 *
 * Copyright (C) 2002, Amaury Jacquot
 *
 * Amaury Jacquot <sxpert@esitcom.org>
 * Carl Worth <cworth@isi.edu>
 *
 * This program is free software, distributed under the terms of
 * the GNU General Public License
 */

#ifndef _cairo_widget_h_
#define _cairo_widget_h_

#include <gdk/gdk.h>
#include <gtk/gtkwidget.h>

#define CAIRO_WIDGET(obj)		GTK_CHECK_CAST (obj, cairo_widget_get_type(), CairoWidget)
#define CAIRO_WIDGET_CLASS(klass)	GTK_CHECK_CLASS_CAST	(klass, cairo_widget_get_type(), CairoWidgetClass)
#define IS_CAIRO_WIDGET(obj)		GTK_CHECK_TYPE			(obj, cairo_widget_get_type())

typedef struct _CairoWidget	CairoWidget;
typedef struct _CairoWidgetClass CairoWidgetClass;

typedef struct _CairoWidgetRectangle {
    int x1, y1;
    int x2, y2;
    double red, green, blue;
} CairoWidgetRectangle;

#define CAIRO_WIDGET_NUM_RECTS 10

struct _CairoWidget {
    GtkWidget widget;
    int width, height;
    CairoWidgetRectangle rects[CAIRO_WIDGET_NUM_RECTS];
};

struct _CairoWidgetClass {
    GtkWidgetClass parent_class;
};

GtkType
cairo_widget_get_type (void);

GtkWidget *
cairo_widget_new (void);

void
cairo_widget_randomize (CairoWidget *cw);

#endif
