#include <gtkcairo.h>
#include "puzzle.h"


GtkWidget *win;

static void
puzzle_solved (GtkWidget * widget, gpointer data) {
    GtkWidget *dialog;
    GtkWidget *label;

    dialog = gtk_dialog_new_with_buttons ("GtkCairoSlide - solved",
                                          GTK_WINDOW (win),
                                          GTK_DIALOG_MODAL,
                                          GTK_STOCK_OK, GTK_RESPONSE_ACCEPT,
                                          NULL);

    label = gtk_label_new ("You solved the puzzle!");
    gtk_misc_set_padding (GTK_MISC (label), 20, 20);
    gtk_widget_show (label);


    gtk_container_add (GTK_CONTAINER (GTK_DIALOG(dialog)->vbox), label);
    gtk_widget_show (dialog);

    gtk_dialog_run (GTK_DIALOG (dialog));
    gtk_main_quit ();
}

static void
show_game (void) {
    GtkWidget *vbox;
    GtkWidget *puzzle;

	win = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title (GTK_WINDOW (win), "Sliding GtkCairo Puzzle");
	g_signal_connect (G_OBJECT (win), "delete-event",
	                  G_CALLBACK (gtk_main_quit), NULL);

	vbox = gtk_vbox_new (FALSE, 6);
	gtk_container_set_border_width (GTK_CONTAINER (vbox), 12);

    puzzle = puzzle_new ();

    g_object_set (G_OBJECT (puzzle), "rows", 4, NULL);
    g_object_set (G_OBJECT (puzzle), "cols", 4, NULL);
    g_object_set (G_OBJECT (puzzle), "shuffles", 2048, NULL);

	gtk_widget_set_usize (GTK_WIDGET (puzzle), 192, 192);

    g_signal_connect (G_OBJECT (puzzle), "puzzle_solved",
                      G_CALLBACK (puzzle_solved), puzzle);

	gtk_container_add (GTK_CONTAINER (vbox), puzzle);

	gtk_container_add (GTK_CONTAINER (win), vbox);
	gtk_widget_show_all (vbox);
	gtk_widget_show (win);
}

int
main (int argc, char *argv[]) {
	gtk_init (&argc, &argv);
	show_game ();
	gtk_main ();

	return 0;
}

